#
#   Boolean-Based Blind SQL injection support for MySQL
#
class Msf::Exploit::SQLi::Mssqli::BooleanBasedBlind < Msf::Exploit::SQLi::Mssqli::Common
  include Msf::Exploit::SQLi::BooleanBasedBlindMixin

  #
  # This method checks if the target is vulnerable to Blind boolean-based injection by checking that
  # the values returned by the block for some boolean queries are correct.
  #
  def test_vulnerable
    out_true = blind_request('1=1')
    out_false = blind_request('1=2')
    out_true && !out_false
  end
end
